#
#  $Id: Memo.py,v 1.5 1999/02/02 02:33:03 rob Exp $
#
#  Copyright 1998-1999 Rob Tillotson <robt@debian.org>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU Library General Public License, version 2,
#  as published by the Free Software Foundation.
#
#  This program is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Library General Public License for more details.
#
#  You should have received a copy of the GNU Library General Public License
#  along with this program; if not, write the Free Software Foundation,
#  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
#
"""Memo Pad.
"""

__version__ = '$Id: Memo.py,v 1.5 1999/02/02 02:33:03 rob Exp $'

__copyright__ = 'Copyright 1998-1999 Rob Tillotson <robt@debian.org>'

import PDA.Palm
import PDA.Palm.App
from PDA.Palm import FLD_STRING, FLD_BOOLEAN
import struct, string
from PDA.Palm import Blocks

class App(PDA.Palm.App.App):
    name = 'Memo'
    version = '$Version$'
    author = 'Rob Tillotson <robt@debian.org>'
    url = ''
    description = 'The built in memo pad.'

    def classify(self, info={}):
	if info.get('type') == 'DATA' and info.get('creator') == 'memo':
	    return Database
	
class Record(Blocks.Record):
    def __init__(self, *a, **kw):
	self.fields = {'text': (FLD_STRING, '')}
	apply(Blocks.Record.__init__, (self,)+a, kw)

    def unpack(self, raw):
	self.raw = raw
	self.data['text'] = string.split(raw,'\0')[0]

    def pack(self):
	self.raw = self.data['text']+'\0'
	return self.raw

class AppBlock(Blocks.CategoryAppBlock):
    def __init__(self, *a, **kw):
	self.fields = { 'sortByAlpha': (FLD_BOOLEAN, 0) }
	apply(Blocks.CategoryAppBlock.__init__, (self,)+a, kw)

    def unpack(self, raw):
	self.raw = raw
	raw = Blocks.CategoryAppBlock.unpack(self, raw)
	if len(raw) < 4: self.data['sortByAlpha'] = 0
	else:
	    self.data['sortByAlpha'] = int(struct.unpack('>B', raw[2])[0])
	
    def pack(self):
	self.raw = Blocks.CategoryAppBlock.pack(self)
	self.raw = self.raw + '\0\0' + chr(self.data['sortByAlpha']) + '\0'
	return self.raw

class Database(PDA.Palm.Database):
    def __init__(self, db, info):
	PDA.Palm.Database.__init__(self, db, info)
	self.record_class = Record
	self.appblock_class = AppBlock

PDA.Palm.Types.register(Database, {'type': 'DATA', 'creator': 'memo'})


