#
#  $Id: Filter.py,v 1.2 1999/02/02 02:33:04 rob Exp $
#
#  Copyright 1998-1999 Rob Tillotson <robt@debian.org>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU Library General Public License, version 2,
#  as published by the Free Software Foundation.
#
#  This program is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Library General Public License for more details.
#
#  You should have received a copy of the GNU Library General Public License
#  along with this program; if not, write the Free Software Foundation,
#  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
#
"""Import/Export Filters.

  This subpackage implements the import/export filter architecture.
  It shares many similarities with the conduit architecture; however,
  we do not simply use the conduit architecture because import/export
  filters are not an exact match:

    - they do not require or even suggest a connection to the device
    - they usually operate on a record-by-record database
    - they do not synchronize
    - they might be invokable individually, instead of as part of a
      sync run


  The following properties (see the Plugin interface) can be set on
  filter instances:

    'import'  - the filter can import
    'export'  - the filter can export
"""

__version__ = '$Id: Filter.py,v 1.2 1999/02/02 02:33:04 rob Exp $'

__copyright__ = 'Copyright 1998-1999 Rob Tillotson <robt@debian.org>'


import sys
from PDA.Palm import Plugin


class Filter(Plugin.Plugin):
    """
    Superclass for all filters.
    """
    type = 'Filter'
    def __init__(self, *a, **kw):
	apply(Plugin.Plugin.__init__, (self,)+a, kw)

	self.applications = []

    def handles_app(self, app):
	"""Test whether this filter handles a particular application.
	"""
	return app in self.applications

    # A filter may have internal state which restricts it to performing
    # one import or export at a time.

    def import_begin(self, app, *a, **kw):
	pass

    def import_end(self, *a, **kw):
	pass

    def import_record(self, *a, **kw):
	pass

    def export_begin(self, app, *a, **kw):
	pass

    def export_end(self, *a, **kw):
	pass

    def export_record(self, rec, *a, **kw):
	pass
    
