#
#  $Id: UserDirectory.py,v 1.1 1999/02/02 02:33:05 rob Exp $
#
#  Copyright 1999 Rob Tillotson <robt@debian.org>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU Library General Public License, version 2,
#  as published by the Free Software Foundation.
#
#  This program is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Library General Public License for more details.
#
#  You should have received a copy of the GNU Library General Public License
#  along with this program; if not, write the Free Software Foundation,
#  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
#
"""An arbitrary subdirectory of a user's data area.
"""

__version__ = '$Id: UserDirectory.py,v 1.1 1999/02/02 02:33:05 rob Exp $'

__copyright__ = 'Copyright 1999 Rob Tillotson <robt@debian.org>'

from PDA.Palm.Store import Directory
import PDA.Palm.Config
import os

class Store(Directory.Store):
    name = 'UserDirectory'
    author = 'Rob Tillotson <robt@debian.org>'
    version = '$Version$'
    description = 'PRC/PDB files in a user subdirectory.'
    
    def __init__(self, directory='backup', username=None, registry=None):
	if registry is None:
	    registry = PDA.Palm.Config.PalmRegistry()
	    registry.load()

	if username is None:
	    username = registry.get('defaults','user',None)

	if username is None:
	    raise RuntimeError, 'no username specified'

	path = os.path.join(registry.user_directory(username), directory)

	Directory.Store.__init__(self,path)

	self.configure(registry)
	
