#
#  $Id: debug.py,v 1.1 1999/02/02 02:32:56 rob Exp $
#
#  Copyright 1999 Rob Tillotson <robt@debian.org>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU Library General Public License, version 2,
#  as published by the Free Software Foundation.
#
#  This program is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Library General Public License for more details.
#
#  You should have received a copy of the GNU Library General Public License
#  along with this program; if not, write the Free Software Foundation,
#  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
#
"""Debugging aids.
"""

__version__ = '$Id: debug.py,v 1.1 1999/02/02 02:32:56 rob Exp $'

__copyright__ = 'Copyright 1999 Rob Tillotson <robt@debian.org>'

import sys, string

def dump_raw(s, f=sys.stdout):
    """Dump a string in hex/ascii format, not unlike what 'pilot-file' does."""
    x = 0
    while 1:
	t = s[:16]
	s = s[16:]
	if not t: break
	
	f.write('%04x:' % x)

	for c in t:
	    f.write(' %02x' % ord(c))

	if len(t) < 16:
	    f.write('   ' * (16 - len(t)))

	f.write('   ')

	for c in t:
	    if ord(c) >= 0x20 and ord(c) <= 0x7e:
		f.write(c)
	    else:
		f.write('.')

	f.write('\n')
	x = x + 16

